package dev.flyfish.framework.r2dbc;

import dev.flyfish.framework.r2dbc.config.R2dbcDataConfig;
import dev.flyfish.framework.r2dbc.domain.TestDO;
import dev.flyfish.framework.r2dbc.domain.TestQO;
import dev.flyfish.framework.r2dbc.repository.TestAssoRepository;
import dev.flyfish.framework.r2dbc.repository.TestRepository;
import dev.flyfish.framework.utils.JacksonUtil;
import jakarta.annotation.Resource;
import lombok.extern.slf4j.Slf4j;
import org.junit.jupiter.api.Test;
import org.junit.jupiter.api.extension.ExtendWith;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.boot.autoconfigure.SpringBootApplication;
import org.springframework.boot.test.context.SpringBootTest;
import org.springframework.context.annotation.Import;
import org.springframework.test.context.junit.jupiter.SpringExtension;

import java.util.List;

@ExtendWith(SpringExtension.class)
@SpringBootTest(classes = R2DbcRepositoryTest.class)
@SpringBootApplication(scanBasePackages = "dev.flyfish.framework")
@Import(R2dbcDataConfig.class)
@Slf4j
public class R2DbcRepositoryTest {

    @Resource
    private TestRepository testRepository;
    @Autowired
    private TestAssoRepository testAssoRepository;

    @Test
    public void test() {
        TestQO qo = new TestQO();
        qo.setName("1");
        // 开启关联查询
        qo.setFetchRef(true);

        TestDO test = new TestDO();
        test.setId("100");
        test.setCode("ttt");
        test.setName("测试名称");
        test.setOtherId("1");

        // 打印插入结果
        log.info("插入结果:{}", JacksonUtil.toPrettyJson(testRepository.insert(test).block()));
        // 查询生成
        log.info("生成查询:{}", JacksonUtil.toPrettyJson(testRepository.findByNameContaining("名").block()));
        List<TestDO> all = testRepository.findAll(qo).collectList().block();
        log.info("qo查询:{}", JacksonUtil.toPrettyJson(all));
        // 修改值并保存测试
        all.get(0).getAsso().setName("修改后的值");
        log.info("批量保存:{}", JacksonUtil.toPrettyJson(testRepository.saveAll(all).collectList().block()));
        log.info("id查询:{}", JacksonUtil.toPrettyJson(testAssoRepository.findById("1").block()));
    }
}
