package dev.flyfish.framework.dict.config;

import dev.flyfish.framework.dict.annotations.EnableDictProcess;
import org.apache.commons.collections4.MapUtils;
import org.springframework.beans.factory.support.BeanDefinitionRegistry;
import org.springframework.context.annotation.ImportBeanDefinitionRegistrar;
import org.springframework.core.type.AnnotationMetadata;

import java.util.Map;

/**
 * 字典配置
 *
 * @author wangyu
 */
public class DictionaryConfig implements ImportBeanDefinitionRegistrar {

    public static DictionaryConfig INSTANCE;
    private String[] basePackages;

    public DictionaryConfig() {
        INSTANCE = this;
    }

    public static String[] basePackages() {
        if (null != INSTANCE) {
            return INSTANCE.basePackages;
        }
        return null;
    }

    /**
     * 注册bean定义，可以从这里取得元数据，自动加载bean
     *
     * @param metadata 元数据
     * @param registry 注册器
     */
    @Override
    public void registerBeanDefinitions(AnnotationMetadata metadata, BeanDefinitionRegistry registry) {
        Map<String, Object> attrs = metadata.getAnnotationAttributes(EnableDictProcess.class.getCanonicalName(), true);
        this.basePackages = (String[]) MapUtils.getObject(attrs, "basePackages");
    }

}
