package dev.flyfish.framework.dict.domain;

import dev.flyfish.framework.domain.base.AuditDomain;
import lombok.Getter;
import lombok.Setter;
import org.apache.commons.lang3.StringUtils;
import org.springframework.data.mongodb.core.mapping.Document;
import org.springframework.data.relational.core.mapping.Table;

import java.util.List;
import java.util.Objects;

/**
 * 字典表，包含字典值
 *
 * @author wangyu
 */
@Getter
@Setter
@Document(collection = "dictionaries")
@Table("t_dictionary")
public class Dictionary extends AuditDomain {

    // 字典表的值
    private List<DictionaryValue> values;

    // 字典描述
    private String description;

    @Override
    public boolean equals(Object o) {
        if (this == o) return true;
        if (!(o instanceof Dictionary)) return false;
        if (StringUtils.isBlank(code)) {
            return super.equals(o);
        }
        Dictionary that = (Dictionary) o;
        return StringUtils.equals(this.code, that.code);
    }

    @Override
    public int hashCode() {
        if (StringUtils.isBlank(code)) {
            return super.hashCode();
        }
        return Objects.hash(getCode());
    }
}
