package dev.flyfish.framework.utils;

import org.springframework.security.authentication.BadCredentialsException;
import org.springframework.security.core.AuthenticationException;

import java.util.Map;

/**
 * 认证消息
 * @author wangyu
 */
public interface AuthenticationMessages {

   String DEFAULT_MESSAGE = "用户登录异常！";

    // todo 剩下的都在userDetailsService
     Map<Class<? extends AuthenticationException>, String> DESCRIPTION_MAP = MapBuilder.<Class<? extends AuthenticationException>, String>builder()
             .put(BadCredentialsException.class, "用户名密码不正确!")
             .build();

    /**
     * 消息构建，通过异常
     * @param exception 异常
     * @return 结果
     */
     static String message(AuthenticationException exception) {
         return DESCRIPTION_MAP.getOrDefault(exception.getClass(), exception.getMessage());
     }
}
